> ## Documentation Index
> Fetch the complete documentation index at: https://docs.domino.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Register model through config



## OpenAPI

````yaml /api-specs/cloud/dmm.json put /model-monitor/v2/api/model
openapi: 3.0.3
info:
  description: The API for programmatic access to Domino Model Monitor.
  title: Domino Model Monitor API
  version: 1.0.1
servers:
  - description: >-
      Replace 'mycluster.domino.tech' with your Domino cluster hostname. For
      Domino Cloud customers, that is `your-subdomain`.domino.tech (e.g.,
      acme.domino.tech). For self-hosted deployments, it is the hostname you
      reach the Domino UI at.
    url: https://mycluster.domino.tech
security: []
tags:
  - description: All Dataset Job related operations.
    name: DatasetJob
  - description: All data source related operations.
    name: DataSource
  - description: All Model related operations.
    name: Model
  - description: Operations related to the management of model tags.
    name: ModelTag
  - description: All Model drift related operations.
    name: ModelDrift
  - description: All Model quality related operations.
    name: ModelQuality
  - description: All Workbench related operations.
    name: Workbench
  - description: Operations related to drift and model quality defaults setting in DMM.
    name: DefaultSettings
  - description: Operations related to configuring user related settings for DMM.
    name: UserSettings
  - description: >-
      Operations related to configuring notification channel config and alert
      recipients for the model.
    name: Notification
  - description: Other miscellaneous operations.
    name: Other
  - description: All scheduler related operations
    name: Scheduler
paths:
  /model-monitor/v2/api/model:
    summary: Model Operations.
    put:
      tags:
        - Model
      summary: Register model through config
      operationId: registerModelThroughConfig
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/modelRegistrationConfigRequest'
        description: ''
        required: true
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/modelResponse'
          description: Successfully registered the Model.
        '400':
          description: Bad request input data.
        '403':
          description: Forbidden. The endpoint enforces permissions.
        '405':
          description: Method not allowed.
        '500':
          description: Internal server error, check server logs.
      security:
        - DominoApiKeyAuth: []
        - DmmApiKeyAuth: []
        - cookieAuth: []
        - BearerAuth: []
components:
  schemas:
    modelRegistrationConfigRequest:
      allOf:
        - $ref: '#/components/schemas/datasetRegistrationConfigRequest'
        - properties:
            modelMetadata:
              $ref: '#/components/schemas/model'
          required:
            - modelMetadata
          type: object
      description: Config to be used to register a model with DMM.
      title: Model Registration Config
    modelResponse:
      allOf:
        - $ref: '#/components/schemas/modelResponseCommon'
        - properties:
            permissions:
              $ref: '#/components/schemas/modelPermissions'
          type: object
    datasetRegistrationConfigRequest:
      description: Config to be used to register a model with DMM.
      properties:
        datasetDetails:
          $ref: '#/components/schemas/datasetConfigRegistrationRequest'
        run_cohort_analysis:
          type: boolean
        variables:
          items:
            $ref: '#/components/schemas/variableConfigRegistrationRequest'
          type: array
      required:
        - datasetDetails
      title: Model Registration Config
      type: object
    model:
      description: Model Config to be used to register a model with DMM.
      properties:
        author:
          description: Author of the Model.
          type: string
        dateCreated:
          description: The creation date of the model.
          nullable: true
          type: integer
        description:
          description: Description for the Model.
          type: string
        modelType:
          description: Type of the Model.
          enum:
            - classification
            - regression
          type: string
        name:
          description: Name of the Model.
          type: string
        sourceDetails:
          $ref: '#/components/schemas/workbenchModelDetails'
        sourceType:
          $ref: '#/components/schemas/sourceType'
        version:
          description: Version of the Model.
          type: string
      required:
        - name
        - modelType
        - version
      title: Model Config
      type: object
    modelResponseCommon:
      allOf:
        - $ref: '#/components/schemas/model'
        - properties:
            collaborators:
              items:
                $ref: '#/components/schemas/collaborator'
              type: array
            createdAt:
              description: Creation timestamp of the Model.
              type: integer
            id:
              description: Model Identifier.
              type: string
            ingestionStatus:
              description: Dataset Ingestion status for a model.
              enum:
                - created
                - training
                - prediction
                - ground_truth
              type: string
            isDeleted:
              description: Whether the model is deleted or not.
              type: boolean
            ownerEmail:
              description: email of the model owner, who created the model.
              type: string
            ownerName:
              description: name of the model owner, who created the model.
              type: string
            ownerUsername:
              description: username of the model owner, who created the model.
              type: string
            registrationStatus:
              description: Registration status of a model.
              enum:
                - draft
                - created
                - deleted
              type: string
            tags:
              description: List of tags associated with the model
              items:
                $ref: '#/components/schemas/modelTag'
              type: array
            updatedAt:
              description: Last update timestamp for the Model.
              type: integer
            userId:
              description: Id of the model owner, who created the model.
              type: string
            visibility:
              $ref: '#/components/schemas/visibility'
          required:
            - id
            - createdAt
            - updatedAt
            - userId
            - ingestionStatus
            - registrationStatus
            - isDeleted
          type: object
    modelPermissions:
      description: Permission metadata required for a model response
      properties:
        canEditPermissions:
          description: Whether the requesting user can edit permissions for the model
          type: boolean
        canRegisterDataset:
          description: Whether the requesting user can register a dataset for the model
          type: boolean
        canUpdateMonitoringSettings:
          description: >-
            Whether the requesting user can update monitoring settings for the
            model
          type: boolean
      required:
        - canRegisterDataset
        - canUpdateMonitoringSettings
        - canEditPermissions
      title: Model Permissions
      type: object
    datasetConfigRegistrationRequest:
      description: Config for the dataset to be registered with the model.
      properties:
        datasetConfig:
          $ref: '#/components/schemas/datasetConfig'
        datasetType:
          description: Type of the dataset.
          enum:
            - file
          type: string
        datasourceName:
          description: Name of the datasource to which the dataset belongs.
          type: string
        datasourceType:
          $ref: '#/components/schemas/datasourceType'
        featureSetId:
          description: The version id for the current feature set version.
          type: string
        featureSetVersionId:
          description: >-
            The feature set id of the feature set to which the current feature
            set version belongs to.
          type: string
        name:
          description: Name of the dataset.
          type: string
      required:
        - name
        - datasetType
        - datasetConfig
        - datasourceName
        - datasourceType
      title: Dataset Config Registration
      type: object
    variableConfigRegistrationRequest:
      description: Variable config to configure a variable of a model.
      properties:
        binsCategories:
          description: Bin categories to be used for a categorical typed variable.
          items:
            type: string
          type: array
        binsEdges:
          description: Bin Edges to be used for a numerical typed variable.
          items:
            type: number
          type: array
        binsEstimatorMethod:
          $ref: '#/components/schemas/binsEstimatorMethod'
        binsNum:
          $ref: '#/components/schemas/binCount'
        featureImportance:
          description: Feature Importance for a feature variable.
          type: number
        forPredictionOutput:
          description: Corresponding prediction variable name, for the given variable.
          type: string
        name:
          description: Name of the variable.
          type: string
        precomputedBinCounts:
          description: Precomputed counts for bins.
          items:
            type: integer
          type: array
        predictionProbabilityLabels:
          description: Labels for the prediction probabilities.
          items:
            type: string
          type: array
        valueType:
          $ref: '#/components/schemas/valueType'
        variableType:
          $ref: '#/components/schemas/variableType'
      required:
        - name
        - valueType
        - variableType
      title: Variable Config Registration
      type: object
    workbenchModelDetails:
      description: Model details associated with a Domino workbench model.
      properties:
        workbenchModelId:
          description: Workbench's Model id
          type: string
        workbenchModelVersionId:
          description: Workbench Model's version id to be monitored in DMM
          type: string
      required:
        - workbenchModelId
        - workbenchModelVersionId
      title: Domino Workbench model's details.
      type: object
    sourceType:
      description: Source for the model registration.
      enum:
        - domino_workbench
        - standalone
      type: string
    collaborator:
      description: Collaborator for a standalone model
      properties:
        collaboratorLevel:
          $ref: '#/components/schemas/collaboratorLevel'
        userId:
          description: user id of the collaborator
          type: string
      required:
        - userId
        - collaboratorLevel
      type: object
    modelTag:
      description: Tag for a model
      properties:
        id:
          type: string
        tagName:
          description: name of tag
          type: string
      required:
        - id
        - tagName
      title: Model Tag
    visibility:
      description: Model visibility
      enum:
        - public
        - private
      type: string
    datasetConfig:
      description: Config for the dataset.
      properties:
        fileFormat:
          $ref: '#/components/schemas/fileFormat'
        path:
          description: Path to the dataset in the datasource.
          type: string
      required:
        - path
        - fileFormat
      type: object
    datasourceType:
      description: Type of the datasource to which the dataset belongs.
      enum:
        - s3
        - generic_s3
        - azure_blob
        - azure_data_lake_gen_2
        - google_cloud_storage
        - azure_data_lake_gen_1
        - hdfs
        - nfs
        - snowflake
      type: string
    binsEstimatorMethod:
      description: Estimator method to be used to determine the number of bins.
      enum:
        - auto
        - doane
        - fd
        - rice
        - scott
        - sqrt
        - sturges
      type: string
    binCount:
      description: Number of bins to be determined (for training datasets)
      type: integer
    valueType:
      description: Type of data the variable has.
      enum:
        - categorical
        - numerical
        - string
        - datetime
      type: string
    variableType:
      description: Variable type.
      enum:
        - feature
        - prediction
        - row_identifier
        - timestamp
        - ground_truth
        - sample_weight
        - prediction_probability
      type: string
    collaboratorLevel:
      description: type of collaborator
      enum:
        - editor
        - viewer
      type: string
    fileFormat:
      description: Format of the file.
      enum:
        - csv
        - parquet
        - snowflake
      type: string
  securitySchemes:
    DominoApiKeyAuth:
      in: header
      name: X-Domino-Api-Key
      type: apiKey
    DmmApiKeyAuth:
      in: header
      name: X-DMM-API-KEY
      type: apiKey
    cookieAuth:
      in: cookie
      name: PLAY_SESSION
      type: apiKey
    BearerAuth:
      scheme: bearer
      type: http

````

## Related topics

- [Register a Model](/cloud/platform-capabilities/features/monitoring/4-set-up-model-monitor/3-register-a-model.md)
- [Manage models with model registry](/cloud/platform-capabilities/features/models/register-and-govern/model-registry.md)
- [Register models](/cloud/platform-capabilities/features/models/register-and-govern/index.md)
- [Register dataset config](/api-reference/model/register-dataset-config.md)
